public class PgcConsts
{
    //! \name ConstsSec
    //! Constants section
    //!@{

    //! Version
    public const string PGC_API_VERSION = "1.68.170829"; //!< Version

    //! Error codes
    public const int PGC_ERR_NONE = 0;   //!< No error
    public const int PGC_ERR_NONE_ASYNC = -1;  //!< No error, async
    public const int PGC_ERR_NONE_FIRST = -11;  //!< No error, first
    public const int PGC_ERR_NONE_LAST = -12;  //!< No error, last
    public const int PGC_ERR_NONE_MARKER = -100; //!< No error, marker
    public const int PGC_ERR_GENERAL = -101; //!< General error
    public const int PGC_ERR_NOTSUPPORTED = -102; //!< Not supported
    public const int PGC_ERR_PARAM_INVALID = -111; //!< Parameter invalid
    public const int PGC_ERR_SVC_NOTFOUND = -121; //!< Service not found
    public const int PGC_ERR_SVC_REGISTERFAILED = -122; //!< Register-service failed
    public const int PGC_ERR_CONN_NOTFOUND = -201; //!< Connection not found
    public const int PGC_ERR_CONN_INITFAILED = -202; //!< Connection-initialize failed
    public const int PGC_ERR_CONN_OPTNOTFOUND = -203; //!< Connection option not found
    public const int PGC_ERR_CONN_ALREADYCONNECTED = -211; //!< Connection already connected
    public const int PGC_ERR_CONN_ALREADYDISCONNECTED = -212; //!< Connection already disconnected
    public const int PGC_ERR_CONN_NOTCONNECTED = -213; //!< Connection not connected
    public const int PGC_ERR_CONN_CBKNOTREGISTERED = -221; //!< Connection callback not registered
    public const int PGC_ERR_CONN_ALREADYLISTENING = -231; //!< Connection already listening
    public const int PGC_ERR_CONN_NOTLISTENING = -232; //!< Connection not listening
    public const int PGC_ERR_SESS_NOTFOUND = -301; //!< Session not found
    public const int PGC_ERR_SESS_INITFAILED = -302; //!< Session-initialize failed
    public const int PGC_ERR_SESS_MSGCNTINVALID = -311; //!< Session message count invalid
    public const int PGC_ERR_SESS_MSGCNTALREADYSET = -312; //!< Session message count already set
    public const int PGC_ERR_SESS_NOTSOURCE = -321; //!< Session not in source state
    public const int PGC_ERR_MSG_NOTFOUND = -401; //!< Message not found
    public const int PGC_ERR_MSG_IDXOUTOFBOUND = -402; //!< Message index out of bound
    public const int PGC_ERR_MSG_FIELDNOTFOUND = -403; //!< Message field not found
    public const int PGC_ERR_MSG_OBJINVALID = -404; //!< Message object invalid
    public const int PGC_ERR_MSG_SIZEINVALID = -405; //!< Message size invalid
    public const int PGC_ERR_MSG_KEYINVALID = -406; //!< Message key invalid
    public const int PGC_ERR_MSG_WRITEFAILED = -411; //!< Write-message failed
    public const int PGC_ERR_NET_URLINVALID = -501; //!< Network URL invalid
    public const int PGC_ERR_NET_REFINVALID = -502; //!< Network reference invalid
    public const int PGC_ERR_NET_INITFAILED = -503; //!< Initialize-network failed
    public const int PGC_ERR_NET_INFONOTFOUND = -504; //!< Network info not found
    public const int PGC_ERR_NET_STSNOTFOUND = -505; //!< Network status/statistics not found
    public const int PGC_ERR_NET_CONNECTFAILED = -511; //!< Network-connect failed
    public const int PGC_ERR_NET_HANDSHAKEFAILED = -512; //!< Network-handshake failed
    public const int PGC_ERR_NET_DISCONNECTFAILED = -513; //!< Network-disconnect failed
    public const int PGC_ERR_NET_SENDFAILED = -521; //!< Network-send failed
    public const int PGC_ERR_NET_RECVFAILED = -522; //!< Network-receive failed
    public const int PGC_ERR_NET_FLUSHFAILED = -523; //!< Network-flush failed
    public const int PGC_ERR_NET_PERFORMFAILED = -524; //!< Network-perform failed
    public const int PGC_ERR_NET_TIMEDOUT = -531; //!< Network timed out
    public const int PGC_ERR_NET_LISTENFAILED = -541; //!< Network-listen failed
    public const int PGC_ERR_NET_UNLISTENFAILED = -542; //!< Network-unlisten failed
    public const int PGC_ERR_NET_CLOSED = -551; //!< Network-closed
    public const int PGC_ERR_EXT_IDINVALID = -10101; //!< Ext: ID invalid
    public const int PGC_ERR_EXT_KEYINVALID = -10102; //!< Ext: Key invalid
    public const int PGC_ERR_EXT_TAGINVALID = -10103; //!< Ext: Tag invalid
    public const int PGC_ERR_EXT_PWDINVALID = -10111; //!< Ext: password invalid
    public const int PGC_ERR_EXT_METHODINVALID = -10121; //!< Ext: method invalid
    public const int PGC_ERR_EXT_IDNOTFOUND = -10201; //!< Ext: ID not found
    public const int PGC_ERR_EXT_KEYNOTFOUND = -10202; //!< Ext: Key not found
    public const int PGC_ERR_EXT_TAGNOTFOUND = -10203; //!< Ext: Tag not found
    public const int PGC_ERR_EXT_IDXOUTOFBOUND = -10304; //!< Ext: Index out of bound
    public const int PGC_ERR_EXT_PWDNOTMATCHED = -10411; //!< Ext: Password not matched
    public const int PGC_ERR_EXT_ALREADYDONE = -10701; //!< Ext: Already done
    public const int PGC_ERR_END = -99999; //!< Err: End

    //! Data types
    public const int PGC_TYPE_NULL = 0;   //!< Null; Unknown
    public const int PGC_TYPE_STR = 101; //!< String
    public const int PGC_TYPE_NUM = 102; //!< Number
    public const int PGC_TYPE_BOOL = 103; //!< Boolean
    public const int PGC_TYPE_DATE = 111; //!< Date/time
    public const int PGC_TYPE_INT = 121; //!< Integer
    public const int PGC_TYPE_AMT = 122; //!< Amount
    public const int PGC_TYPE_OBJ = 201; //!< Object
    public const int PGC_TYPE_ARR = 202; //!< Array

    //! Timeout Indicators (used in the nTimeout field in NewConn function)
    public const int PGC_TIMEO_DEF = 0;    //!< Default
    public const int PGC_TIMEO_API = -101; //!< API: 5 secs
    public const int PGC_TIMEO_API_LL = -102; //!< API with low latency: 2 secs
    public const int PGC_TIMEO_TXN = -111; //!< Transaction: 10 secs
    public const int PGC_TIMEO_TXN_UI = -113; //!< Transaction with UI: 2 mins
    public const int PGC_TIMEO_BATCH = -121; //!< Batch: 5 mins
    public const int PGC_TIMEO_MSG = -131; //!< Message: 15 secs
    public const int PGC_TIMEO_MSG_LL = -132; //!< Message with low latency: 5 secs
    public const int PGC_TIMEO_FILE = -141; //!< File: 2 hrs

    //! Message operation targets (used in the nMsgCnt field in NewSess function)
    public const int PGC_MSGOP_REGULAR = 1;    //!< Regular message
    public const int PGC_MSGOP_SESSDEF = -101; //!< Session default message

    //!@}


}
