Module PgcKeys

'! \cond
    '! \endcond

    '! \file
    '! Payment Gateway Client Keys
    '! \n Strings are all in UTF-8 encoding

    ''''''''''''''''''''''''''''''''''''''''

    '! \name KeySepSec
    '! key separator section
    '!@{

    Public Const PGC_KEY_SEP_CELL As String = "-" ' key cell separator (lower than an item); (the result contains one word: up-to-date)
    Public Const PGC_KEY_SEP_ITEM As String = "_" ' key item separator; (the result contains two words, but one term: new_york)
    Public Const PGC_KEY_SEP_GRP  As String = "~" ' key group separator (higher than an item); the result contains two separate terms, but may limit the scope: sales~florida)

    Public Const PGC_KEY_SEP_JSON As String = "/" ' JSON key separator
    Public Const PGC_KEY_SEP_PROP As String = "." ' property key separator

    '!@}


    '! \name KeyEnvSec
    '! Environment variable keys section
    '!@{

    Public Const PGC_ENVKEY_UNAME As String = "PGC_UNAME" '!< Environment variable: Unique name

    '!@}


    '! \name KeyGenSec
    '! General keys section
    '!@{

    '! General
    Public Const PGC_GENVAL_EMPTY As String = ""  '!< Empty
    Public Const PGC_GENVAL_TRUE  As String = "Y" '!< True, Yes
    Public Const PGC_GENVAL_FALSE As String = "N" '!< False, No

    '!@}


    '! \name KeyPropSec
    '! Property keys section
    '!@{

    '! Connection Properties
    Public Const PGC_CONNPROPSEC_CONNPRM As String = "Conn-Prm" '!< Connection parameter

    Public Const PGC_CONNPROPKEY_URL     As String = "Url"      '!< URL
    Public Const PGC_CONNPROPKEY_UNAME   As String = "UName"    '!< Unique name
    Public Const PGC_CONNPROPKEY_PWD     As String = "Pwd"      '!< Password
    Public Const PGC_CONNPROPKEY_TIMEOUT As String = "Timeout"  '!< Timeout

    Public Const PGC_CONNPROPSEC_SESSDEF As String = "Sess-Def" '!< Session default

    '!@}


    '! \name KeyOptSec
    '! Option keys section
    '!@{

    '! Connection Options
    Public Const PGC_CONNOPT_PREFIX  As String = "xConnOpt_" '!< Connection option prefix

    Public Const PGC_CONNOPTKEY_TIMEO        As String = "xConnOpt_Timeout" '!< Int: Time out
    Public Const PGC_CONNOPTVAL_TIMEO_API    As String = "5000"   '!< API: 5 secs
    Public Const PGC_CONNOPTVAL_TIMEO_API_LL As String = "2000"   '!< API with low latency: 2 secs
    Public Const PGC_CONNOPTVAL_TIMEO_TXN    As String = "10000"  '!< Transaction: 10 secs
    Public Const PGC_CONNOPTVAL_TIMEO_TXN_UI As String = "120000" '!< Transaction with UI: 120 secs
    Public Const PGC_CONNOPTVAL_TIMEO_BATCH  As String = "300000" '!< Batch: 300 secs
    Public Const PGC_CONNOPTVAL_TIMEO_MSG    As String = "15000"  '!< Message: 15 secs
    Public Const PGC_CONNOPTVAL_TIMEO_MSG_LL As String = "5000"   '!< Message with low latency: 5 secs
    Public Const PGC_CONNOPTVAL_TIMEO_FILE   As String = "7200000" '!< File: 2 hrs

    Public Const PGC_CONNOPTKEY_MSGFRAMING      As String = "xConnOpt_MsgFraming" '!< Str: Message framing; Def: 101
    Public Const PGC_CONNOPTVAL_MSGFRAMING_STX  As String = "101"                 '!< Str: STX/ETX message framing

    Public Const PGC_CONNOPTKEY_USESTRFMT       As String = "xConnOpt_UseStrFmt" '!< Bool: Use string format; Def: Y

    Public Const PGC_CONNOPTKEY_CLNCERTFILEPATH As String = "xConnOpt_ClnCertFilePath" '!< Str: Client certificate file path; Def: pgccrt_cln.pem
    Public Const PGC_CONNOPTKEY_SVRCERTFILEPATH As String = "xConnOpt_SvrCertFilePath" '!< Str: Server certificate file path; Def: pgccrt_svr.pem
    Public Const PGC_CONNOPTKEY_SVRKEYFILEPATH  As String = "xConnOpt_SvrKeyFilePath"  '!< Str: Server key file path;         Def: pgckey_svr.pem

    Public Const PGC_CONNOPTKEY_CIPHERLIST      As String = "xConnOpt_CipherList"      '!< Str: Cipher list;                  Def: empty (can be set to As String = "DEFAULT:!SHA:!MD5:!3DES:!RC4")

    Public Const PGC_CONNOPTKEY_LASTERRCODE     As String = "xConnOpt_LastErrCode" '!< Int: Last error code, set it (reset it)

    Public Const PGC_CONNOPTKEY_ISSYNCMODE      As String = "xConnOpt_IsSyncMode"   '!< Bool: Is synchronous (non-async) mode; Def: N
    Public Const PGC_CONNOPTKEY_ISMULTITRANS    As String = "xConnOpt_IsMultiTrans" '!< Bool: Is multi-trans mode (not disconnect after each request); Def: Y

    Public Const PGC_CONNOPTKEY_WAITBEFOREHANDSHAKE  As String = "xConnOpt_WaitBeforeHandshake"   '!< Int: Wait before handshake;  Def: 50
    Public Const PGC_CONNOPTKEY_WAITBEFOREHANDSHAKE2 As String = "xConnOpt_WaitBeforeHandshake2"  '!< Int: Wait before handshake2; Def: 50
    Public Const PGC_CONNOPTKEY_WAITBEFORERECEIVE    As String = "xConnOpt_WaitBeforeReceive"     '!< Int: Wait before receive in request; Def: 50

    Public Const PGC_CONNOPTKEY_WAITAFTERCONNECT As String = "xConnOpt_WaitAfterConnect"  '!< Int: Wait after connect; Def: 100
    Public Const PGC_CONNOPTKEY_WAITAFTERHEED    As String = "xConnOpt_WaitAfterHeed"     '!< Int: Wait after heed;    Def: 100
    Public Const PGC_CONNOPTKEY_WAITAFTERLISTEN  As String = "xConnOpt_WaitAfterListen"   '!< Int: Wait after listen;  Def: 100
    Public Const PGC_CONNOPTKEY_WAITAFTERPOLL    As String = "xConnOpt_WaitAfterPoll"     '!< Int: Wait after poll;   Def: 10
    Public Const PGC_CONNOPTKEY_WAITAFTERACCEPT  As String = "xConnOpt_WaitAfterAccept"   '!< Int: Wait after accept; Def: 10

    Public Const PGC_CONNOPTKEY_WAITAFTERFAILEDCONNECT As String = "xConnOpt_WaitAfterFailedConnect"  '!< Int: Wait after failed connect; Def: 1000


    '! Session Options

    '!@}


    '! \name KeyStsSec
    '! Status/Statistics keys section
    '!@{

    '! Connection Status/Statistics
    Public Const PGC_CONNSTSKEY_PREFIX       As String = "xConnSts_"  '!< Connection stat prefix

    Public Const PGC_CONNSTSKEY_LASTERRCODE  As String = "xConnSts_LastErrCode"  '!< Int: Last error code

    Public Const PGC_CONNSTSPFX_CAP          As String = "xConnSts_Cap_"         '!< Prefix for Capability
    Public Const PGC_CONNSTSKEY_CAP_SYNCCLN  As String = "xConnSts_Cap_SyncCln"  '!< Bln: Capability: Supports sync client
    Public Const PGC_CONNSTSKEY_CAP_ASYNCCLN As String = "xConnSts_Cap_AsyncCln" '!< Bln: Capability: Supports async client
    Public Const PGC_CONNSTSKEY_CAP_FILECLN  As String = "xConnSts_Cap_FileCln"  '!< Bln: Capability: Supports file client
    Public Const PGC_CONNSTSKEY_CAP_ASYNCSVR As String = "xConnSts_Cap_AsyncSvr" '!< Bln: Capability: Supports async server

    Public Const PGC_CONNSTSPFX_TS                    As String = "xConnSts_TS_"                  '!< Prefix for Timestamp
    Public Const PGC_CONNSTSKEY_TS_INIT_BEGIN         As String = "xConnSts_TS_InitBegin"         '!< Str: Timestamp: Init Begin
    Public Const PGC_CONNSTSKEY_TS_INIT_END           As String = "xConnSts_TS_InitEnd"           '!< Str: Timestamp: Init End
    Public Const PGC_CONNSTSKEY_TS_UNINIT_BEGIN       As String = "xConnSts_TS_UninitBegin"       '!< Str: Timestamp: Uninit Begin
    Public Const PGC_CONNSTSKEY_TS_UNINIT_END         As String = "xConnSts_TS_UninitEnd"         '!< Str: Timestamp: Uninit End
    Public Const PGC_CONNSTSKEY_TS_CONNECT_BEGIN      As String = "xConnSts_TS_ConnectBegin"      '!< Str: Timestamp: Connect Begin
    Public Const PGC_CONNSTSKEY_TS_CONNECT_HANDSHAKE  As String = "xConnSts_TS_ConnectHandshake"  '!< Str: Timestamp: Connect Handshake (TLS)
    Public Const PGC_CONNSTSKEY_TS_CONNECT_HANDSHAKE2 As String = "xConnSts_TS_ConnectHandshake2" '!< Str: Timestamp: Connect Handshake2 (WSS upgrade)
    Public Const PGC_CONNSTSKEY_TS_CONNECT_END        As String = "xConnSts_TS_ConnectEnd"        '!< Str: Timestamp: Connect End
    Public Const PGC_CONNSTSKEY_TS_CONNECT_FAILED     As String = "xConnSts_TS_ConnectFailed"     '!< Str: Timestamp: Connect Failed
    Public Const PGC_CONNSTSKEY_TS_DISCONNECT_BEGIN   As String = "xConnSts_TS_DisconnectBegin"   '!< Str: Timestamp: Disconnect Begin
    Public Const PGC_CONNSTSKEY_TS_DISCONNECT_END     As String = "xConnSts_TS_DisconnectEnd"     '!< Str: Timestamp: Disconnect End
    Public Const PGC_CONNSTSKEY_TS_REQUEST_BEGIN      As String = "xConnSts_TS_RequestBegin"      '!< Str: Timestamp: Request Begin
    Public Const PGC_CONNSTSKEY_TS_REQUEST_RECV       As String = "xConnSts_TS_RequestRecv"       '!< Str: Timestamp: Request Recv
    Public Const PGC_CONNSTSKEY_TS_REQUEST_END        As String = "xConnSts_TS_RequestEnd"        '!< Str: Timestamp: Request End
    Public Const PGC_CONNSTSKEY_TS_SEND_BEGIN         As String = "xConnSts_TS_SendBegin"         '!< Str: Timestamp: Send Begin
    Public Const PGC_CONNSTSKEY_TS_SEND_END           As String = "xConnSts_TS_SendEnd"           '!< Str: Timestamp: Send End
    Public Const PGC_CONNSTSKEY_TS_CONFIRM_BEGIN      As String = "xConnSts_TS_ConfirmBegin"      '!< Str: Timestamp: Confirm Begin
    Public Const PGC_CONNSTSKEY_TS_CONFIRM_END        As String = "xConnSts_TS_ConfirmEnd"        '!< Str: Timestamp: Confirm End
    Public Const PGC_CONNSTSKEY_TS_REPLY_BEGIN        As String = "xConnSts_TS_ReplyBegin"        '!< Str: Timestamp: Reply Begin
    Public Const PGC_CONNSTSKEY_TS_REPLY_END          As String = "xConnSts_TS_ReplyEnd"          '!< Str: Timestamp: Reply End
    Public Const PGC_CONNSTSKEY_TS_NOTIFY_BEGIN       As String = "xConnSts_TS_NotifyBegin"       '!< Str: Timestamp: Notify Begin
    Public Const PGC_CONNSTSKEY_TS_NOTIFY_END         As String = "xConnSts_TS_NotifyEnd"         '!< Str: Timestamp: Notify End
    Public Const PGC_CONNSTSKEY_TS_LISTEN_BEGIN       As String = "xConnSts_TS_ListenBegin"       '!< Str: Timestamp: Listen Begin
    Public Const PGC_CONNSTSKEY_TS_LISTEN_END         As String = "xConnSts_TS_ListenEnd"         '!< Str: Timestamp: Listen End
    Public Const PGC_CONNSTSKEY_TS_UNLISTEN_BEGIN     As String = "xConnSts_TS_UnlistenBegin"     '!< Str: Timestamp: Unlisten Begin
    Public Const PGC_CONNSTSKEY_TS_UNLISTEN_END       As String = "xConnSts_TS_UnlistenEnd"       '!< Str: Timestamp: Unlisten End
    Public Const PGC_CONNSTSKEY_TS_HEED_BEGIN         As String = "xConnSts_TS_HeedBegin"         '!< Str: Timestamp: Heed Begin
    Public Const PGC_CONNSTSKEY_TS_HEED_END           As String = "xConnSts_TS_HeedEnd"           '!< Str: Timestamp: Heed End
    Public Const PGC_CONNSTSKEY_TS_UNHEED_BEGIN       As String = "xConnSts_TS_UnheedBegin"       '!< Str: Timestamp: Unheed Begin
    Public Const PGC_CONNSTSKEY_TS_UNHEED_END         As String = "xConnSts_TS_UnheedEnd"         '!< Str: Timestamp: Unheed End
    Public Const PGC_CONNSTSKEY_TS_PERFORM_BEGIN      As String = "xConnSts_TS_PerformBegin"      '!< Str: Timestamp: Perform Begin
    Public Const PGC_CONNSTSKEY_TS_PERFORM_END        As String = "xConnSts_TS_PerformEnd"        '!< Str: Timestamp: Perform End
    Public Const PGC_CONNSTSKEY_TS_POLL_BEGIN         As String = "xConnSts_TS_PollBegin"         '!< Str: Timestamp: Poll Begin
    Public Const PGC_CONNSTSKEY_TS_POLL_END           As String = "xConnSts_TS_PollEnd"           '!< Str: Timestamp: Poll End
    Public Const PGC_CONNSTSKEY_TS_ACCEPT_BEGIN       As String = "xConnSts_TS_AcceptBegin"       '!< Str: Timestamp: Accept Begin
    Public Const PGC_CONNSTSKEY_TS_ACCEPT_END         As String = "xConnSts_TS_AcceptEnd"         '!< Str: Timestamp: Accept End

    Public Const PGC_CONNSTSKEY_PEERLIST As String = "xConnSts_PeerList" '!< List of connected peers


    '! Session Status/Statistics

    '!@}


    '! \name KeyInfoSec
    '! Info keys section
    '!@{

    '! Peer Info (Other party end point)
    Public Const PGC_PEERINFOKEY_URL      As String = "xPeerInfo_URL"      '!< URL
    Public Const PGC_PEERINFOKEY_ADDR     As String = "xPeerInfo_Addr"     '!< Address
    Public Const PGC_PEERINFOKEY_PORT     As String = "xPeerInfo_Port"     '!< Port
    Public Const PGC_PEERINFOKEY_ADDRPORT As String = "xPeerInfo_AddrPort" '!< Address + Port
    Public Const PGC_PEERINFOKEY_CONNNUM  As String = "xPeerInfo_ConnNum"  '!< Connection number
    Public Const PGC_PEERINFOKEY_PEERLIST As String = "xPeerInfo_PeerList" '!< List of connected peers

    '!@}


    '! \name KeyHostSec
    '! Host keys section
    '!@{

    '! Hosts: special host names have brackets around
    Public Const PGC_HOST_ANY   As String = "[any]"     '!< broadcast
    Public Const PGC_HOST_SVR   As String = "[svr]"     '!< server
    Public Const PGC_HOST_LOCAL As String = "localhost" '!< local host
    Public Const PGC_IP_LOCAL   As String = "127.0.0.1" '!< local host IP
    Public Const PGC_IP_BCAST   As String = "255.255.255.255" '!< broadcast IP
    Public Const PGC_IP_ALL     As String = "0.0.0.0"   '!< server IP

    '! Lists: special list elements
    Public Const PGC_LIST_HOSTPORT_ALL As String = "(all)" '!< all host:port pairs
    Public Const PGC_LIST_ADDRPORT_ALL As String = "(all)" '!< all addr:port pairs
    Public Const PGC_LIST_TOPIC_ALL    As String = "(all)" '!< all topics

    '!@}


    '! \name KeySvcSec
    '! Service keys section
    '!@{

    '! WSL: WEB Service Locator: service names start with $; web scope service names start with $WEB-
    Public Const PGC_SVC_C9PG_PWE      As String = "$WEB-C9PG-PWE"      '!< Payment Web Engine
    Public Const PGC_SVC_C9PG_WBS      As String = "$WEB-C9PG-WBS"      '!< Web Batch Service
    Public Const PGC_SVC_C9PG_NUM      As String = "$WEB-C9PG-NUM"      '!< Number Service

    Public Const PGC_SVC_C9PG_PWE_TEST As String = "$WEB-C9PG-PWE-TEST" '!< Payment Web Engine Test
    Public Const PGC_SVC_C9PG_WBS_TEST As String = "$WEB-C9PG-WBS-TEST" '!< Web Batch Service Test
    Public Const PGC_SVC_C9PG_NUM_TEST As String = "$WEB-C9PG-NUM-TEST" '!< Number Service Test

    '! LSL: LAN Service Locator: service names start with $; LAN scope service names start with $LAN-
    Public Const PGC_SVC_N1CL_TXN As String = "$LAN-N1CL-TXN" '!< CreditLine Transaction Service
    Public Const PGC_SVC_N1CL_API As String = "$LAN-N1CL-API" '!< CreditLine API Service

    '! HSL: HOST Service Locator: service names start with $; host scope service names start with $HOST-
    Public Const PGC_SVC_C9PG_PDC As String = "$HOST-C9PG-PDC" '!< Payment Device Controller
    Public Const PGC_SVC_C9PG_DBS As String = "$HOST-C9PG-DBS" '!< Device Batch Service


    ' URLs - defaults
    Public Const PGC_URL_C9PG_PWE      As String = "https:'link.c9pg.com:5568/restApi"  '!< Payment Web Engine default URL; As String = "https:'link.c9pg.com:5551/hj"
    Public Const PGC_URL_C9PG_WBS      As String = "https:'link.c9pg.com:5566/bchApi"   '!< Web Batch Service default URL
    Public Const PGC_URL_C9PG_NUM      As String = "https:'link.c9pg.com:16869/numApi"  '!< Number Service default URL

    Public Const PGC_URL_C9PG_PWE_TEST As String = "https:'testlink.c9pg.com:5568/restApi"  '!< Payment Web Engine Test default URL; As String = "https:'testlink.c9pg.com:5551/hj"
    Public Const PGC_URL_C9PG_WBS_TEST As String = "https:'testlink.c9pg.com:5566/bchApi"   '!< Web Batch Service Test default URL
    Public Const PGC_URL_C9PG_NUM_TEST As String = "https:'testlink.c9pg.com:16869/numApi"  '!< Number Service Test default URL

    Public Const PGC_URL_C9PG_PDC      As String = "wss:'127.0.0.1:5556/"             '!< Payment Device Controller default URL
    Public Const PGC_URL_C9PG_DBS      As String = "wss:'127.0.0.1:5556/"             '!< Device Batch Service default URL

    '!@}


    '! \name KeyMsgPrmSec
    '! Message parameter keys section
    '!@{

    Public Const PGC_MSGPRMKEY_DATE    As String = "xMsgPrm_Date"    '!< Str: date
    Public Const PGC_MSGPRMKEY_FROM    As String = "xMsgPrm_From"    '!< Str: from uname
    Public Const PGC_MSGPRMKEY_TO      As String = "xMsgPrm_To"      '!< Str: list of to unames
    Public Const PGC_MSGPRMKEY_SUBJECT As String = "xMsgPrm_Subject" '!< Str: subject; topic
    Public Const PGC_MSGPRMKEY_THREAD  As String = "xMsgPrm_Thread"  '!< Str: thread

    Public Const PGC_MSGPRMKEY_QOS          As String = "xMsgPrm_QoS"          '!< Str: quality of service
    Public Const PGC_MSGPRMVAL_QOS_LTEQONCE As String = "xMsgPrm_QoS_LtEqOnce" '!< Str: QoS: less than or equal to once; at most once; least expensive
    Public Const PGC_MSGPRMVAL_QOS_GTEQONCE As String = "xMsgPrm_QoS_GtEqOnce" '!< Str: QoS: greater than or equal to once; at least once
    Public Const PGC_MSGPRMVAL_QOS_EQONCE   As String = "xMsgPrm_QoS_EqOnce"   '!< Str: QoS: equal to once; exactly once; most expensive

    Public Const PGC_MSGPRMKEY_ISDUP      As String = "xMsgPrm_IsDup"    '!< Bool Str: is duplicate
    Public Const PGC_MSGPRMKEY_TORETAIN   As String = "xMsgPrm_ToRetain" '!< Bool Str: to retain

    Public Const PGC_MSGPRMKEY_MSGID            As String = "xMsgPrm_MsgID"        '!< Str: message ID

    Public Const PGC_MSGPRMKEY_MSGTYPE           As String = "xMsgPrm_MsgType"           '!< Str: message type
    Public Const PGC_MSGPRMVAL_MSGTYPE_NORMAL    As String = "xMsgPrm_MsgType_Normal"    '!< Str: Message type: normal
    Public Const PGC_MSGPRMVAL_MSGTYPE_CHAT      As String = "xMsgPrm_MsgType_Chat"      '!< Str: Message type: chat
    Public Const PGC_MSGPRMVAL_MSGTYPE_GROUPCHAT As String = "xMsgPrm_MsgType_GroupChat" '!< Str: Message type: group chat
    Public Const PGC_MSGPRMVAL_MSGTYPE_HEADLINE  As String = "xMsgPrm_MsgType_Headline"  '!< Str: Message type: headline

    Public Const PGC_MSGPRMKEY_PAYLOAD      As String = "xMsgPrm_Payload"      '!< Str: payload
    Public Const PGC_MSGPRMVAL_PAYLOAD_BODY As String = "xMsgPrm_Payload_Body" '!< Str: payload: body
    Public Const PGC_MSGPRMVAL_PAYLOAD_URL  As String = "xMsgPrm_Payload_Url"  '!< Str: payload: url

    Public Const PGC_MSGPRMKEY_METHOD        As String = "xMsgPrm_Method"        '!< Str: method
    Public Const PGC_MSGPRMVAL_METHOD_POST   As String = "xMsgPrm_Method_Post"   '!< Str: method: post
    Public Const PGC_MSGPRMVAL_METHOD_GET    As String = "xMsgPrm_Method_Get"    '!< Str: method: get
    'Public Const PGC_MSGPRMVAL_METHOD_PUT    As String = "xMsgPrm_Method_Put"    '!< Str: method: put
    'Public Const PGC_MSGPRMVAL_METHOD_DELETE As String = "xMsgPrm_Method_Delete" '!< Str: method: delete

    Public Const PGC_MSGPRMKEY_SUBPATH       As String = "xMsgPrm_SubPath"       '!< Str: sub-path (RESTful API)

    Public Const PGC_MSGPRMKEY_ACCEPT                As String = "xMsgPrm_Accept"        '!< Str: accept
    Public Const PGC_MSGPRMKEY_CONTENTTYPE           As String = "xMsgPrm_ContentType"   '!< Str: content type
    Public Const PGC_MSGPRMVAL_CONTENTTYPE_JSON      As String = "application/json"      '!< Str: content type: JSON
    Public Const PGC_MSGPRMVAL_CONTENTTYPE_TEXT      As String = "text/plain"            '!< Str: content type: TEXT

    Public Const PGC_MSGPRMKEY_TASK             As String = "xMsgPrm_Task"             '!< Str: task
    Public Const PGC_MSGPRMVAL_TASK_GET         As String = "xMsgPrm_Task_Get"         '!< Str: Task: get
    Public Const PGC_MSGPRMVAL_TASK_PUT         As String = "xMsgPrm_Task_Put"         '!< Str: Task: put
    Public Const PGC_MSGPRMVAL_TASK_SUBSCRIBE   As String = "xMsgPrm_Task_Subscribe"   '!< Str: Task: subscribe
    Public Const PGC_MSGPRMVAL_TASK_UNSUBSCRIBE As String = "xMsgPrm_Task_Unsubscribe" '!< Str: Task: unsubscribe

    Public Const PGC_MSGPRMKEY_LOCALPATH  As String = "xMsgPrm_LocalPath"  '!< Str: local path
    Public Const PGC_MSGPRMKEY_REMOTEPATH As String = "xMsgPrm_RemotePath" '!< Str: remote path

    Public Const PGC_MSGPRMKEY_SKIPSRSP   As String = "xMsgPrm_SkipsRsp"   '!< Bool Str: skips response

    '!@}


    '! \name KeyMsgSec
    '! Message keys section
    '!@{

    '! Messages
    Public Const PGC_MSGKEY_PEERADDRPORT As String = "xMsg_PeerAddrPort" '!< in
    Public Const PGC_MSGKEY_SRCTRCNUM    As String = "xMsg_SrcTrcNum"    '!< in
    Public Const PGC_MSGKEY_DSTTRCNUM    As String = "xMsg_DstTrcNum"    '!< in
    Public Const PGC_MSGKEY_SRCUNAME     As String = "xMsg_SrcUName"     '!< in
    Public Const PGC_MSGKEY_DSTUNAME     As String = "xMsg_DstUName"     '!< in
    Public Const PGC_MSGKEY_USERNAME     As String = "xMsg_UserName"     '!< in
    Public Const PGC_MSGKEY_PASSWORD     As String = "*xMsg_Password"    '!< in
    Public Const PGC_MSGKEY_TOKEN        As String = "xMsg_Token"        '!< in
    Public Const PGC_MSGKEY_METHOD       As String = "xMsg_Method"       '!< in

    Public Const PGC_MSGKEY_ACTION         As String = "xMsg_Action"     '!< in
    Public Const PGC_MSGVAL_ACTION_SEND    As String = "xMsgAct_Send"    '!< Action: Send    (client async)
    Public Const PGC_MSGVAL_ACTION_REQUEST As String = "xMsgAct_Request" '!< Action: Request (client sync/async)
    Public Const PGC_MSGVAL_ACTION_REPLY   As String = "xMsgAct_Reply"   '!< Action: Reply   (server async)
    Public Const PGC_MSGVAL_ACTION_NOTIFY  As String = "xMsgAct_Notify"  '!< Action: Notify  (server async)
    Public Const PGC_MSGVAL_ACTION_CONFIRM As String = "xMsgAct_Confirm" '!< Action: Confirm (client async)

    '!@}


    '! \name KeyTimeSec
    '! Stamp keys section
    '!@{

    '! Timestamps
    Public Const PGC_TSKEY_STEP As String = "xTS_Step"  '!< Timestamp Step
    Public Const PGC_TSPFX_NAME As String = "xTS_Name_" '!< Timestamp Prefix: Name
    Public Const PGC_TSPFX_IN   As String = "xTS_In_"   '!< Timestamp Prefix: In
    Public Const PGC_TSPFX_OUT  As String = "xTS_Out_"  '!< Timestamp Prefix: Out

    '!@}


    '! \name KeyParamSec
    '! Parameter keys section
    '!@{

    '! Method Params
    Public Const PGC_PRMKEY_ERRCODE As String = "xPrm_ErrCode" '!< out

    '!@}

    ''''''''''''''''''''''''''''''''''''''''

    '! \name KeyC9Sec
    '! C9PG keys section
    '!@{

    '! C9PG: General
    Public Const PGC_GWVAL_TRUE  As String = "Y" '!< True, Yes
    Public Const PGC_GWVAL_FALSE As String = "N" '!< False, No
    Public Const PGC_GWVAL_YES   As String = "Y" '!< Yes
    Public Const PGC_GWVAL_NO    As String = "N" '!< No

    '! C9PG: Trace
    Public Const PGC_GWKEY_SRCTRACENUM As String = "SourceTraceNum" '!< Str: Source Trace Number; from POS to GW
    Public Const PGC_GWKEY_GTRC        As String = "GTRC"           '!< Str: Gateway Trace; from GW to POS
    Public Const PGC_GWKEY_GTRCLIST    As String = "GTRCList"       '!< StrList: Gateway Trace Number List; from POS/GW to GW/POS

    '! C9PG: Account
    Public Const PGC_GWKEY_GMID As String = "GMID" '!< Str: Gateway Merchant ID; from POS to GW
    Public Const PGC_GWKEY_GTID As String = "GTID" '!< Str: Gateway Device ID; from POS to GW
    Public Const PGC_GWKEY_GMPW As String = "GMPW" '!< Str: Gateway Merchant Password; from POS to GW

    '! C9PG: Option
    Public Const PGC_GWKEY_ALLOWS_PARTIALAUTH As String = "AllowsPartialAuth" '!< Bool: Allows Partial Auth; Def: N; from POS to GW
    Public Const PGC_GWKEY_NEEDS_UI           As String = "NeedSwipeCard"     '!< Bool: Needs the UI popup (NeedSwipCard); from POS to GW

    '! C9PG: Action
    Public Const PGC_GWKEY_TXNACT            As String = "TransType" '!< Str: Transaction Action; Val: Auth, Sale, etc; from POS to GW
    Public Const PGC_GWVAL_TXNACT_SALE       As String = "Sale"      '!< Transaction Action: Sale
    Public Const PGC_GWVAL_TXNACT_AUTH       As String = "Auth"      '!< Transaction Action: Auth
    Public Const PGC_GWVAL_TXNACT_INQUIRY    As String = "Inquiry"   '!< Transaction Action: Inquiry
    Public Const PGC_GWVAL_TXNACT_REFUND     As String = "Refund"    '!< Transaction Action: Refund
    Public Const PGC_GWVAL_TXNACT_FINALIZE   As String = "Finalize"  '!< Transaction Action: Finalize
    Public Const PGC_GWVAL_TXNACT_ADDTIP     As String = "AddTip"    '!< Transaction Action: AddTip
    Public Const PGC_GWVAL_TXNACT_MODIFY     As String = "Modify"    '!< Transaction Action: Modify
    Public Const PGC_GWVAL_TXNACT_VOID       As String = "Void"      '!< Transaction Action: Void
    Public Const PGC_GWVAL_TXNACT_BATCH      As String = "Batch"     '!< Transaction Action: Batch
    Public Const PGC_GWVAL_TXNACT_ADDVALUE   As String = "AddValue"  '!< Transaction Action: AddValue
    Public Const PGC_GWVAL_TXNACT_ACTIVATE   As String = "Active"    '!< Transaction Action: Activate
    Public Const PGC_GWVAL_TXNACT_DEACTIVATE As String = "Deactive"  '!< Transaction Action: Deactivate
    Public Const PGC_GWVAL_TXNACT_SELBATCH   As String = "SelBatch"  '!< Transaction Action: Selective Batch

    Public Const PGC_GWKEY_ISOFFLINE As String = "IsOffline" '!< Bool: Is Offline; Def: N; from POS to GW
    Public Const PGC_GWKEY_AUTHCODE  As String = "AuthCode"  '!< Str: Authorization Code; As String = "from POS to GW" for offline transactions, As String = "from GW to POS" for regular transactions

    '! C9PG: Amount
    Public Const PGC_GWKEY_MAINAMT      As String = "MainAmt"        '!< Amt: Main Amount; from POS to GW
    Public Const PGC_GWKEY_TIPAMT       As String = "TipAmt"         '!< Amt: Tip Amount; from POS to GW
    Public Const PGC_GWKEY_INCTAXAMT    As String = "IncTaxAmt"      '!< Amt: Included Tax Amount; from POS to GW
    Public Const PGC_GWKEY_INCCASHBKAMT As String = "IncCashBackAmt" '!< Amt: Included Cash Back Amount; from POS to GW

    '! C9PG: Tax
    Public Const PGC_GWKEY_TAXIND        As String = "TaxIndicator" '!< Str: Tax Indicator; Def: Prvded; from POS to GW
    Public Const PGC_GWVAL_TAXIND_PRVDED As String = "Prvded"       '!< Tax Indicator: Provided
    Public Const PGC_GWVAL_TAXIND_NTPRVD As String = "Ntprvd"       '!< Tax Indicator: Not Provided
    Public Const PGC_GWVAL_TAXIND_NONTAX As String = "NonTax"       '!< Tax Indicator: Non-taxable

    '! C9PG: Info
    Public Const PGC_GWKEY_INVOICENUM As String = "InvoiceNum" '!< Str: Invoice Number; from POS to GW
    Public Const PGC_GWKEY_ORDERNUM   As String = "OrderNum"   '!< Str: Order Number; from POS to GW
    Public Const PGC_GWKEY_VOUCHERNUM As String = "VoucherNum" '!< Str: Voucher Number; from POS to GW
    Public Const PGC_GWKEY_ADDLINFO   As String = "AdditionalInfo" '!< Str: Additional Info; key value pairs; from POS to GW

    '! C9PG: Card
    Public Const PGC_GWKEY_ACCTNUM    As String = "*AccountNum" '!< Str: Account Number; sensitive data; from POS to GW only if POS controls the enry
    Public Const PGC_GWKEY_EXPDATE    As String = "ExpDate"    '!< Str: Expiration Date; Fmt: MMYY or MM/YY; from POS to GW only if POS controls the entry
    'Public Const PGC_GWKEY_EXPYEAR  As String = "ExpYear"    '!< TBA; Str: Expiration Year
    'Public Const PGC_GWKEY_EXPMONTH As String = "ExpMonth"   '!< TBA; Str: Expiration Month
    Public Const PGC_GWKEY_CVVNUM     As String = "*CVVNum"     '!< Str: CVV, CVC Number; sensitive data; from POS to GW only if POS controls the entry
    'Public Const PGC_GWKEY_TRACK    As String = "*Track"      '!< TBA; Str: MSR Track Data; sensitive data
    Public Const PGC_GWKEY_TRACK1     As String = "*Track1"     '!< Str: MSR Track1; sensitive data; from POS to GW only if POS controls the entry
    Public Const PGC_GWKEY_TRACK2     As String = "*Track2"     '!< Str: MSR Track2; sensitive data; from POS to GW only if POS controls the entry
    Public Const PGC_GWKEY_PINDATA    As String = "*PinData"    '!< Str: PIN Data; sensitive data; from POS to GW only if POS controls the entry
    Public Const PGC_GWKEY_ENCDATA    As String = "EncryptionData" '!< Str: Encryption Data; required when account number is encrypted; from POS to GW only if POS controls the entry
    Public Const PGC_GWKEY_ISCARDPRES As String = "CardPresent"    '!< Bool: Is Card Present; Def: Y; from POS to GW
    Public Const PGC_GWKEY_ISPCARD    As String = "CommercialCard" '!< Bool: Is Purchase / Commercial Card; Def: Y; from POS to GW if known, or from GW to POS using blanket support

    '! C9PG: Card Medium
    Public Const PGC_GWKEY_MDM         As String = "Medium"  '!< Str: Medium; Val: Credit, Debit, Prepaid, EBT, etc; from POS to GW if known
    Public Const PGC_GWVAL_MDM_CREDIT  As String = "Credit"  '!< Medium: Credit
    Public Const PGC_GWVAL_MDM_DEBIT   As String = "Debit"   '!< Medium: Debit
    Public Const PGC_GWVAL_MDM_GIFT    As String = "Gift"    '!< Medium: Gift
    Public Const PGC_GWVAL_MDM_PREPAID As String = "Prepaid" '!< Medium: Prepaid
    Public Const PGC_GWVAL_MDM_EBTFOOD As String = "EBTFood" '!< Medium: EBT Food
    Public Const PGC_GWVAL_MDM_EBTCASH As String = "EBTCash" '!< Medium: EBT Cash

    '! C9PG: Encryption
    Public Const PGC_GWKEY_KEYID         As String = "KeyID"       '!< Str: Key ID; from POS to GW only if POS controls the entry
    Public Const PGC_GWKEY_ENCBLK        As String = "EncrptBlock" '!< Str: Encryption Block; encrypted track data or account number; from POS to GW only if POS controls the entry
    Public Const PGC_GWKEY_ENCTGT        As String = "EncrptTrgt"  '!< Str: Encryption Target; Val: Track1, PAN; from POS to GW only if POS controls the entry
    Public Const PGC_GWVAL_ENCTGT_TRACK1 As String = "Track1" '!< Encryption Target: Track1; from POS to GW only if POS controls the entry
    Public Const PGC_GWVAL_ENCTGT_TRACK2 As String = "Track2" '!< Encryption Target: Track2; from POS to GW only if POS controls the entry
    Public Const PGC_GWVAL_ENCTGT_PAN    As String = "PAN"    '!< Encryption Target: PAN; from POS to GW only if POS controls the entry

    '! C9PG: PIN
    Public Const PGC_GWKEY_PINBLK As String = "*PinBlock" '!< Str: PIN Block; sensitive data; from POS to GW only if POS controls the entry
    Public Const PGC_GWKEY_KSN    As String = "KSN"      '!< Str: KSN; from POS to GW only if POS controls the entry

    '! C9PG: Result
    Public Const PGC_GWKEY_STATUS             As String = "Status"      '!< Str: Status; from GW to POS
    Public Const PGC_GWVAL_STATUS_OK          As String = "success"     '!< Status: OK
    Public Const PGC_GWVAL_STATUS_FAILED      As String = "fail"        '!< Status: Failed
    Public Const PGC_GWVAL_STATUS_TIMEDOUT    As String = "timeout"     '!< Status: Timed Out
    Public Const PGC_GWVAL_STATUS_CANCELED    As String = "cancel"      '!< Status: Canceled
    Public Const PGC_GWVAL_STATUS_DATAINVALID As String = "invalidData" '!< Status: Data Invalid

    Public Const PGC_GWKEY_RSPCODE As String = "ResponseCode" '!< Str: Response Code (processor specific); from GW to POS
    Public Const PGC_GWKEY_RSPTEXT As String = "ResponseText" '!< Str: Response Text (processor specific); from GW to POS
    Public Const PGC_GWKEY_ERRCODE As String = "ErrorCode"    '!< Str: Error Code (processor unified); from GW to POS
    Public Const PGC_GWKEY_ERRTEXT As String = "ErrorText"    '!< Str: Error Text (processor unified); from GW to POS

    'Public Const PGC_GWKEY_AUTHCODE As String = "AuthCode"      '!< Str: Authorization Code; As String = "from POS to GW" for offline transactions, As String = "from GW to POS" for regular transactions
    Public Const PGC_GWKEY_AVSRSTCODE As String = "AVSResultCode" '!< Str: AVS Result Code; from GW to POS
    Public Const PGC_GWKEY_CVVRSTCODE As String = "CVVResultCode" '!< Str: CVV Result Code; from GW to POS

    Public Const PGC_GWKEY_AUTHAMT As String = "AuthAmt"    '!< Amt: Authorized Amount; from GW to POS
    Public Const PGC_GWKEY_BALAMT  As String = "BalanceAmt" '!< Amt: Balance Amount; from GW to POS

    'Public Const PGC_GWKEY_MDM     As String = "Medium"     '!< Str: Medium; Val: Credit Card, Debit Card, Gift Card, EBT, etc; from GW to POS
    'Public Const PGC_GWKEY_ACCTNUM As String = "AccountNum" '!< Str: Account Number; from GW to POS

    '! C9PG: Card Brand
    Public Const PGC_GWKEY_BRAND              As String = "Brand"        '!< Str: Brand; Val: Visa, Master, Discover, Amex, JCB, etc; from GW to POS
    Public Const PGC_GWVAL_BRAND_VISA         As String = "Visa"         '!< Brand: Visa
    Public Const PGC_GWVAL_BRAND_MASTERCARD   As String = "Master"       '!< Brand: MasterCard
    Public Const PGC_GWVAL_BRAND_DISCOVER     As String = "Discover"     '!< Brand: Discover
    Public Const PGC_GWVAL_BRAND_AMEX         As String = "Amex"         '!< Brand: American Express
    Public Const PGC_GWVAL_BRAND_JCB          As String = "JCB"          '!< Brand: JCB
    Public Const PGC_GWVAL_BRAND_CARTEBLANCHE As String = "CarteBlanche" '!< Brand: Carte Blanche
    Public Const PGC_GWVAL_BRAND_DINERSCLUB   As String = "DinersClub"   '!< Brand: Diners Club
    Public Const PGC_GWVAL_BRAND_ENROUTE      As String = "EnRoute"      '!< Brand: EnRoute
    Public Const PGC_GWVAL_BRAND_JAL          As String = "JAL"          '!< Brand: JAL
    Public Const PGC_GWVAL_BRAND_DISNEYHOTEL  As String = "DisneyHotel"  '!< Brand: Disney Hotel
    Public Const PGC_GWVAL_BRAND_DISNEYCARD   As String = "DisneyCard"   '!< Brand: Disney Card

    '! C9PG: Account Entry
    Public Const PGC_GWKEY_ENTRMODE        As String = "EntryMode" '!< Str: Entry Mode; from POS to GW only if POS controls the entry
    Public Const PGC_GWVAL_ENTRMODE_MANUAL As String = "Manual"    '!< Entry Mode: Manual
    Public Const PGC_GWVAL_ENTRMODE_SWIPE  As String = "Swipe"     '!< Entry Mode: Swipe

    '! C9PG: Tokenization
    Public Const PGC_GWKEY_ACCTTOK         As String = "CardToken"        '!< Str: Account Token; representing an account number + exp date; from GW to POS on initial transaction response and from POS to GW on subsequent requests
    Public Const PGC_GWKEY_REQACCTTOK      As String = "RequestCardToken" '!< Bln: Request for Account Token; from POS to GW

    '! C9PG: Compatibility
    '! TXNACT (Transaction Action) = TransType
    'Public Const PGC_GWKEY_TRANSTYPE          As String = "TransType" ' Str: Transaction Type; Val: Auth, Sale, etc
    'Public Const PGC_GWVAL_TRANSTYPE_SALE     As String = "Sale"      ' Transaction Type: Sale
    'Public Const PGC_GWVAL_TRANSTYPE_AUTH     As String = "Auth"      ' Transaction Type: Auth
    'Public Const PGC_GWVAL_TRANSTYPE_INQUIRY  As String = "Inquiry"   ' Transaction Type: Inquiry
    'Public Const PGC_GWVAL_TRANSTYPE_REFUND   As String = "Refund"    ' Transaction Type: Refund
    'Public Const PGC_GWVAL_TRANSTYPE_FINALIZE As String = "Finalize"  ' Transaction Type: Finalize
    'Public Const PGC_GWVAL_TRANSTYPE_ADDTIP   As String = "AddTip"    ' Transaction Type: AddTip
    'Public Const PGC_GWVAL_TRANSTYPE_MODIFY   As String = "Modify"    ' Transaction Type: Modify
    'Public Const PGC_GWVAL_TRANSTYPE_VOID     As String = "Void"      ' Transaction Type: Void
    'Public Const PGC_GWVAL_TRANSTYPE_BATCH    As String = "Batch"     ' Transaction Type: Batch
    'Public Const PGC_GWVAL_TRANSTYPE_ADDVALUE As String = "AddValue"  ' Transaction Type: AddValue
    'Public Const PGC_GWVAL_TRANSTYPE_ACTIVE   As String = "Active"    ' Transaction Type: Activate
    'Public Const PGC_GWVAL_TRANSTYPE_DEACTIVE As String = "Deactive"  ' Transaction Type: Deactivate

    'Public Const PGC_GWKEY_ENTMODE        As String = "EntryMode" '!< Str: Entry Mode; from POS to GW only if POS controls the entry
    'Public Const PGC_GWVAL_ENTMODE_MANUAL As String = "Manual"    '!< Entry Mode: Manual

    '!@}


    '! \name KeyNumSec
    '! Number service keys section
    '!@{

    Public Const PGC_NUMKEY_METHOD               As String = "Method"        '!< Str: Method
    Public Const PGC_NUMVAL_METHOD_REGISTER      As String = "Register"      '!< Method: Register
    Public Const PGC_NUMVAL_METHOD_UNREGISTER    As String = "Unregister"    '!< Method: Unregister
    Public Const PGC_NUMVAL_METHOD_GETNEXT       As String = "GetNext"       '!< Method: GetNext

    Public Const PGC_NUMKEY_ERRCODE              As String = "ErrCode"       '!< Int: Error Code

    Public Const PGC_NUMKEY_TAG                  As String = "Tag"           '!< Str: Tag
    Public Const PGC_NUMKEY_PASSWORD             As String = "Password"      '!< Str: Password
    Public Const PGC_NUMKEY_COUNT                As String = "Count"         '!< Int: Count
    Public Const PGC_NUMKEY_NUMLIST              As String = "NumList"       '!< Str: Number list; separated by commas if counter > 1

    Public Const PGC_NUMKEY_MIN                  As String = "Min"           '!< Int: Minimum
    Public Const PGC_NUMKEY_MAX                  As String = "Max"           '!< Int: Maximum
    Public Const PGC_NUMKEY_RANDOMIZE            As String = "Randomize"     '!< Bln: Randomize
    Public Const PGC_NUMKEY_ADDMOD10DIGIT        As String = "AddMod10Digit" '!< Bln: Add Mod10 Digit
    Public Const PGC_NUMKEY_PREFIX               As String = "Prefix"        '!< Str: Prefix
    Public Const PGC_NUMKEY_SUFFIX               As String = "Suffix"        '!< Str: Suffix

    '!@}

    ''''''''''''''''''''''''''''''''''''''''

    '! Notes
    '! Pointer style JSON keys: /RootObj/SubObj/ArrIdx/Key
    '! Pointer style property keys: RootObj.SubObj-ArrIdx.Key


End Module
